# alarm-mail

- [alarm-mail](#alarm-mail)
  - [Device Properties](#device-properties)
    - [email_name](#email_name)
    - [email_smtp](#email_smtp)
    - [email_user](#email_user)
  - [Commands](#commands)
    - [SendNotification](#sendnotification)

The alarm-mail device server is used for dispatching alarm notifcations vie e-mail. Can be used in conjunction with the [alarm-handler](https://gitlab.elettra.eu/cs/ds/alarm-handler) and [alarm-notify](https://gitlab.elettra.eu/cs/ds/alarm-notify) device servers

## Device Properties

### email_name

String.

Name used as Sender

### email_smtp

String.

SMTP server address

### email_user

String.

Address used as Sender

## Commands

### SendNotification

In: DevString

Out: DevVoid

Send email notification.

The format of the argin is the following:

```
name=;handler=;values=;time=;url=;msg=;formula=;groups=;shlvd_time=;state=;ack=;time=;dest=
```

At least dest and state need to be specified.

`dest` is a comma separated list of email addresses.

`state` is one of `NORM`, `RTNUN`, `UNACK`, `ACKED`, `OOSRV`, `SHLVD`, `ERROR`

argin example:

```
name=test_alarm1;handler=alarm/handler/0;values={'alarm/test/0/attr':1.0};time=2022-12-25 00:00:00;url=;msg='Test alarm';formula=(alarm/test/0/attr == 0);groups=gr_ctrl;state=RTNUN;ack=0;dest=a@b.c
```

Email body example:

```
RESTORED TO NORMAL CONDITION:
Name:    test_alarm1
Handler: alarm/handler/0
State:   RTNUN
Ack:     0
Time:    2022-12-25 00:00:00
Message: 'Test alarm'
Values:  {'alarm/test/0/attr':0}
Formula: (alarm/test/0/attr == 0)
```

## Installation & deployment

Call make to prepare scripts in bin directory.

Copy `bin/alarm-mail*` to the deployment path.

Run as `alarm-mail-srv instance_name`

## Credits

Graziano Scalamera

Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
Strada Statale 14 - km 163,5 in AREA Science Park
34149 Basovizza, Trieste ITALY

## License

GPL 3

