#!/usr/bin/env python
# -*- coding:utf-8 -*-


# ############################################################################
#  license :
# ============================================================================
#
#  File :        AlarmMail.py
#
#  Project :     Alarm Mail Notification
#
# This file is part of Tango device class.
#
# Tango is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Tango is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Tango.  If not, see <http://www.gnu.org/licenses/>.
#
#
#  $Author :      graziano.scalamera$
#
#  $Revision :    $
#
#  $Date :        $
#
#  $HeadUrl :     $
# ============================================================================
#            This file is generated by POGO
#     (Program Obviously used to Generate tango Object)
# ############################################################################

__all__ = ["AlarmMail", "AlarmMailClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(AlarmMail.additionnal_import) ENABLED START -----#
import smtplib
from email.mime.text import MIMEText
import mysql.connector
from mysql.connector import errorcode
from datetime import datetime, timedelta
import re
import json

#----- PROTECTED REGION END -----#	//	AlarmMail.additionnal_import

# Device States Description
# No states for this device


class AlarmMail (PyTango.LatestDeviceImpl):
    """"""

    # -------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(AlarmMail.global_variables) ENABLED START -----#
    addressBook= {
        }
    att_conf_Map= {
        }
    att_conf_fqdn_Map= {
        }
    #----- PROTECTED REGION END -----#	//	AlarmMail.global_variables

    def __init__(self, cl, name):
        PyTango.LatestDeviceImpl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        AlarmMail.init_device(self)
        #----- PROTECTED REGION ID(AlarmMail.__init__) ENABLED START -----#

        #----- PROTECTED REGION END -----#	//	AlarmMail.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(AlarmMail.delete_device) ENABLED START -----#

        #----- PROTECTED REGION END -----#	//	AlarmMail.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        #----- PROTECTED REGION ID(AlarmMail.init_device) ENABLED START -----#
        for dest in self.receivers:
                self.addressBook[dest.split('=')[0]] = dest.split('=')[1]
        if len(self.hdbpp_host) > 0:
            hdbpp=mysql.connector.MySQLConnection()
            try:
                hdbpp = mysql.connector.connect(user=self.hdbpp_user, password=self.hdbpp_password, host=self.hdbpp_host, database=self.hdbpp_dbname)
                hdbppcursor = hdbpp.cursor(named_tuple=True)
                hdbppcursor.execute("SELECT att_name, att_conf_id FROM att_conf")
                word = '([a-zA-Z0-9\+\._\*\#\-]+)'
                numport = '([0-9]+)'
                for row in hdbppcursor:
                    m = re.compile("tango://"+word+':'+numport+"/"+word+"/"+word+"/"+word+"/"+word).match(row.att_name)
                    if m is not None:
                        att=m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4]+"/"+m.groups()[5]
                        #remove network domain fron fqdn
                        self.att_conf_fqdn_Map["tango://"+((m.groups()[0]).split('.')[0])+':'+m.groups()[1]+"/"+m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4]+"/"+m.groups()[5]] = row.att_conf_id
                        #print("* TANGO_HOST:{tango_host} -> {att_name}: {att_conf_id}".format(
                        #	tango_host=m.groups()[0],
                        #	att_name=att,
                        #	att_conf_id=row.att_conf_id
                        #))
                    else:
                        self.att_conf_fqdn_Map[row.att_name] = row.att_conf_id
                        att=row.att_name
                        #print("* TANGO_HOST:default -> {att_name}: {att_conf_id}".format(
                        #	att_name=att,
                        #	att_conf_id=row.att_conf_id
                        #))
                    self.att_conf_Map[att] = row.att_conf_id
                    
            except mysql.connector.Error as err:
                if err.errno == errorcode.ER_ACCESS_DENIED_ERROR:
                    self.set_status("HDB++: wrong username or password")
                elif err.errno == errorcode.ER_BAD_DB_ERROR:
                    self.set_status("HDB++: database not existing")
                else:
                    self.set_status("HDB++: " + err)
                hdbpp.close()
        #----- PROTECTED REGION END -----#	//	AlarmMail.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(AlarmMail.always_executed_hook) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.always_executed_hook

    # -------------------------------------------------------------------------
    #    AlarmMail read/write attribute methods
    # -------------------------------------------------------------------------


    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(AlarmMail.read_attr_hardware) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.read_attr_hardware

    # -------------------------------------------------------------------------
    #    AlarmMail command methods
    # -------------------------------------------------------------------------
    def SendAlarm(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendAlarm()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarm) ENABLED START -----#  
        params= {
        }
        prev_key=''
        prev_value=''
        for param in argin.split(';'):
            if len(param) == 0:
                continue
            try:
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                prev_key=param.split('=',1)[0]
                prev_value=param.split('=',1)[1]
            except IndexError as e:
                #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                self.debug_stream('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                params[prev_key] += ';'+param
                #print('looping param=' + param)
        #print(params)

        dtnow = datetime.now()
        dtstart = dtnow - timedelta(hours=24)
        dtnow = dtnow + timedelta(hours=1)
        stop_date = dtnow.strftime("%Y-%m-%d %H:%M:%S")
        start_date = dtstart.strftime("%Y-%m-%d %H:%M:%S")
	
        #values= {
        #}
        msg_link = ''
        alm_url=''
        att_conf_str = ''
        values=[]
        starter_names=[]
        starter_msg=''
        
        if params['values'].startswith('{'):
            self.debug_stream('SendAlarm: json values -> ' + params['values'])
            jsonval=json.loads(params['values'])
            self.debug_stream('SendAlarm: type jsonval -> ' + str(type(jsonval)))
            for key, value in jsonval.items():
                values+=[key+'='+str(value).replace('"', '')]
        else:
            values=params['values'].split(',')
        for value in values:
            #values[value.split('=',1)[0]] = value.split('=',1)[1]
            att = value.split('=',1)[0]
            if len(att) == 0:
                continue
            #print('looping value=' + value + ' len(value.split(''='',1)[0])=')
            #print('looping value=' + value)
            #print(len(att))
            #print('  -> ' + value.split('=',1)[0])
            word = '([a-zA-Z0-9\+\._\*\#\-]+)'
            numport = '([0-9]+)'
            #ind = r'\[[0-9]+\]);'
            ind = r'(\[(.*?)\])?'
            try:
                m = re.compile("tango://"+word+':'+numport+"/"+word+"/"+word+"/"+word+"/"+word+ind).match(att) #match fqdn with ind
                if m is not None:
                    att="tango://"+(m.groups()[0]).split('.')[0]+":"+m.groups()[1]+"/"+m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4]+"/"+m.groups()[5]
                    if m.groups()[2]=='tango' and m.groups()[3]=='admin':
                        starter_names.append("tango://"+m.groups()[0]+":"+m.groups()[1]+"/"+m.groups()[2]+"/"+m.groups()[3]+"/"+m.groups()[4])
                    att_conf_id=self.att_conf_fqdn_Map[att]
                else:
                    m1 = re.compile(word+"/"+word+"/"+word+"/"+word+ind).match(value.split('=',1)[0]) #match NOT fqdn with ind
                    if m1 is not None:
                        att=m1.groups()[0]+"/"+m1.groups()[1]+"/"+m1.groups()[2]+"/"+m1.groups()[3]
                        if m1.groups()[0]=='tango' and m1.groups()[1]=='admin':
                            starter_names.append(m1.groups()[0]+"/"+m1.groups()[1]+"/"+m1.groups()[2])
                        att_conf_id=self.att_conf_Map[att]
                    else:						#try NOT fqdn without ind
                        att=value.split('=',1)[0]
                        att_conf_id=self.att_conf_Map[att]
                if len(att_conf_str) == 0:
                    att_conf_str = str(att_conf_id)+',1,1'
                else:
                    att_conf_str += ';' + str(att_conf_id)+',1,1'

            except Exception as e:
                #print 'Cannot find att_conf_id for ', att
                self.debug_stream('Cannot find att_conf_id for ' + att) 
                #print e

        if len(att_conf_str) > 0 and len(self.egiga_url) > 0:
            link = self.egiga_url+'&start='+start_date+'&stop='+stop_date+'&ts='+att_conf_str+'&show_error='
            msg_link = '<a href="'+link+'">'+link+'</a><br>'

        for starter in starter_names:
            try:
                starter_dev = PyTango.DeviceProxy(starter)
                dev_errs=starter_dev.command_inout('DevGetStopServers',0)
                for de in dev_errs:
                    starter_msg=starter_msg+'\n'+de
            except (PyTango.DevFailed,PyTango.ConnectionFailed,PyTango.EventSystemFailed) as e:
                print('Error DevGetStopServers: '+str(e[0]['desc']))

        url=''
        try:
            url=params['url']
        except KeyError as e:
            url=''
            #print e
        handler_text=''
        handler_html=''
        try:
            handler_text='\nHandler:  ' + params['handler']
            handler_html='<br>Handler: &nbsp;&nbsp;&nbsp;&nbsp;' +  params['handler']
        except KeyError as e:
            handler_text=''
            handler_html=''
        state_text=''
        state_html=''
        try:
            state_text='\nState:    ' + params['state']
            state_html='<br>State: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['state']
        except KeyError as e:
            state_text=''
            state_html=''
        ack_text=''
        ack_html=''
        try:
            ack_text='\nAck:      ' + params['ack']
            ack_html='<br>Ack: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['ack']
        except KeyError as e:
            ack_text=''
            ack_html=''
        time_text=''
        time_html=''
        try:
            time_text='\nTime:     ' + params['time']
            time_html='<br>Time: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['time']
            #print time_html
        except KeyError as e:
            time_text=''
            time_html=''

        starter_msg_text=''
        starter_msg_html=''
        if len(starter_msg) > 0:
            starter_msg_text='\n\nNot Running Servers:\n'+starter_msg
            starter_msg_html='<br><br>Not Running Servers:<br>'+starter_msg

        if len(url) == 0:
            if len(msg_link) == 0:
                    msg = MIMEText('NEW ALARM DETECTED: \nName:     ' +params['name'] +
                    handler_text +
                    state_text +
                    ack_text +
                    time_text +
                    '\nMessage:  ' + params['msg'] +
                    '\nValues:   ' + params['values'] +
                    '\nFormula:  ' + params['formula']+
                    starter_msg_text)
            else:
                    msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] +
                    handler_html +
                    state_html +
                    ack_html +
                    time_html +
                    '<br>Message: &nbsp;&nbsp;' + params['msg'] +
                    '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] +
                    '<br>Formula: &nbsp;&nbsp;' + params['formula']+
                    '<br><br>HDB++ eGiga link:<br><br>'+msg_link+starter_msg_html+'</p></body></html>','html')
        else:
            alm_url='<a href="'+url+'">'+url+'</a>'
            if len(msg_link) == 0:
                msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] +
                handler_html +
                state_html +
                ack_html +
                time_html +
                '<br>Message: &nbsp;&nbsp;&nbsp;&nbsp;' + params['msg'] +
                '<br>Alarm URL: &nbsp;' + alm_url +
                '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] +
                '<br>Formula: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['formula']+
                starter_msg_html+'</p></body></html>','html')
            else:
                msg = MIMEText('<html><head></head><body><p>NEW ALARM DETECTED: <br>Name: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +params['name'] +
                handler_html +
                state_html +
                ack_html +
                time_html +
                '<br>Message: &nbsp;&nbsp;&nbsp;&nbsp;' + params['msg'] +
                '<br>Alarm URL: &nbsp;' + alm_url +
                '<br>Values: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['values'] +
                '<br>Formula: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + params['formula']+
                '<br><br>HDB++ eGiga link:<br><br>'+msg_link+starter_msg_html+'</p></body></html>','html')

        self.SendMail(params, msg, 'ALARMED')
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarm
    def SendNormal(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendNormal()")
        #----- PROTECTED REGION ID(AlarmMail.SendNormal) ENABLED START -----#
        params= {
        }
        prev_key=''
        prev_value=''
        for param in argin.split(';'):
            if len(param) == 0:
                continue
            try:
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                prev_key=param.split('=',1)[0]
                prev_value=param.split('=',1)[1]
            except IndexError as e:
                #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                self.debug_stream('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                params[prev_key] += ';'+param

        handler=''
        try:
            handler='\nHandler: ' + params['handler']
        except KeyError as e:
            handler=''
        state=''
        try:
            state='\nState:   ' + params['state']
        except KeyError as e:
            state=''
        ack=''
        try:
            ack='\nAck:     ' + params['ack']
        except KeyError as e:
            ack=''
        time_text=''
        try:
            time_text='\nTime:    ' + params['time']
        except KeyError as e:
            time_text=''
        msg = MIMEText('RESTORED TO NORMAL CONDITION: \nName:    ' +params['name'] +
        handler +
        state +
        ack +
        time_text +
        '\nMessage: ' + params['msg'] +
        '\nValues:  ' + params['values'] +
        '\nFormula: ' + params['formula'])
        self.SendMail(params, msg, 'RESTORED')
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendNormal
    def SendAlarmHDB(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendAlarmHDB()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarmHDB) ENABLED START -----#
        params= {
        }
        prev_key=''
        prev_value=''
        for param in argin.split(';'):
            if len(param) == 0:
                continue
            try:
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                prev_key=param.split('=',1)[0]
                prev_value=param.split('=',1)[1]
            except IndexError as e:
                #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                self.debug_stream('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                params[prev_key] += ';'+param
        att_list=[]
        err_list=[]
        hdbppes=''
        #print(params)
        word = '([a-zA-Z0-9\+\._\*\#\-]+)'
        word2 = '([a-zA-Z0-9\+\.\*\#\-]+)'
        word3 = '([a-zA-Z0-9_\+\.\*\#\-]*)'
        m = re.compile(word+"/"+word+"/"+word+"/"+word).match(params['name'])
        if m is not None:
            hdbppes = m.groups()[0]+"/"+m.groups()[1]+"/"+m.groups()[2]
        else:
            m = re.compile("hdbppes_"+word2+"_"+word2+word3).match(params['name'])
            if m is not None:
                if len(m.groups()) == 3:
                    hdbppes = "archiving/hdb++archiver/"+m.groups()[0]+'-'+m.groups()[1]
                else:
                    hdbppes = "archiving/hdb++archiver/"+m.groups()[0]
        if len(hdbppes) > 0:
            self.debug_stream('SendAlarmHDB: dev hdb++='+hdbppes) 
            dev = PyTango.DeviceProxy(hdbppes)
            try:
                #tmp_nok = dev.read_attribute("AttributeNokList")
                tmp_errs = dev.read_attribute("AttributeErrorList")
                tmp_list = dev.read_attribute("AttributeList")
                #nok_list = tmp_nok.value
                err_list = tmp_errs.value
                att_list = tmp_list.value
                #comb_list = map(lambda x,y:(x,y),att_list,err_list)
            except (DevFailed, ConnectionFailed, EventSystemFailed) as e:
                print('Error read_attribute: '+str(e[0]['desc']))


        comb_list = map(lambda x,y:(x,y),att_list,err_list)
        msg_hdb = ''
        for iii in comb_list:
            if len(iii[1]) > 0:
                msg_hdb += iii[0]+'\n'+iii[1]+'\n\n'
        handler=''
        try:
            handler='\nHandler: ' + params['handler']
        except KeyError as e:
            handler=''
        state=''
        try:
            state='\nState:   ' + params['state']
        except KeyError as e:
            state=''
        ack=''
        try:
            ack='\nAck:     ' + params['ack']
        except KeyError as e:
            ack=''
        time_text=''
        try:
            time_text='\nTime:    ' + params['time']
        except KeyError as e:
            time_text=''
        msg = MIMEText('NEW ALARM DETECTED: \nName:    ' +params['name'] +
        handler +
        state +
        ack +
        time_text +
        '\nMessage: ' + params['msg'] +
        '\nValues:  ' + params['values'] +
        '\nFormula: ' + params['formula']+
        '\n\nHDB++ Errors:\n\n'+msg_hdb)
        self.SendMail(params, msg, 'ALARMED')    
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarmHDB
    def SendAlarmPROCFS(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendAlarmPROCFS()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarmPROCFS) ENABLED START -----#
        self.SendAlarm(argin)
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarmPROCFS
    def SendNotification(self, argin):
        """ 
        :param argin:     Semicolon separated arguments, ex:
            name=tagname;values={``alarm/beamstatus/0/medium2[0]``:0};url=;msg=``Test alarm``;formula=(alarm/beamstatus/0/medium2 == 1);groups=gr_ctrl;state=RTNUN;ack=0;dest= name@elettra.eu,;
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendNotification()")
        #----- PROTECTED REGION ID(AlarmMail.SendNotification) ENABLED START -----#
        params= {
        }
        prev_key=''
        prev_value=''
        for param in argin.split(';'):
            if len(param) == 0:
                continue
            try:
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                prev_key=param.split('=',1)[0]
                prev_value=param.split('=',1)[1]
            except IndexError as e:
                #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                self.debug_stream('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                params[prev_key] += ';'+param
        #print(params)
        name=params['name']
        state=params['state']

        hdbppes=False
        word = '([a-zA-Z0-9\+\._\*\#\-]+)'
        word2 = '([a-zA-Z0-9\+\.\*\#\-]+)'
        m = re.compile(word+"/"+word+"/"+word+"/"+word).match(name)
        if m is not None:
            hdbppes = True
        else:
            m = re.compile("hdbppes_"+word2+"_"+word2).match(name)
            if m is not None:
                hdbppes = True

        if state in ['NORM','RTNUN']:
            self.SendNormal(argin)
        elif state in ['UNACK','ACKED']:
            if hdbppes and len(self.hdbpp_host) > 0:
                self.SendAlarmHDB(argin)
            else:
                self.SendAlarm(argin)
        elif state in ['OOSRV','SHLVD']:
            self.SendDisabled(argin)
        elif state in ['ERROR']:
            self.SendError(argin)
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendNotification
    def SendDisabled(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendDisabled()")
        #----- PROTECTED REGION ID(AlarmMail.SendDisabled) ENABLED START -----#
        params= {
        }
        prev_key=''
        prev_value=''
        for param in argin.split(';'):
            if len(param) == 0:
                continue
            try:
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                prev_key=param.split('=',1)[0]
                prev_value=param.split('=',1)[1]
            except IndexError as e:
                #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                self.debug_stream('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                params[prev_key] += ';'+param
        disbled_type=''
        if params['state'] in ['OOSRV']:
            disbled_type= ' permanently (OutOfService)'
        elif params['state'] in ['SHLVD']:
            disbled_type= ' for ' + params['shlvd_time'] + ' minutes (Shelved)'
        handler=''
        try:
            handler='\nHandler: ' + params['handler']
        except KeyError as e:
            handler=''
        state=''
        try:
            state='\nState:   ' + params['state']
        except KeyError as e:
            state=''
        ack=''
        try:
            ack='\nAck:     ' + params['ack']
        except KeyError as e:
            ack=''
        time_text=''
        try:
            time_text='\nTime:    ' + params['time']
        except KeyError as e:
            time_text=''
        msg = MIMEText('DISABLED'+disbled_type+': \nName:    '+params['name'] +
        handler +
        state +
        ack +
        time_text +
        '\nMessage: ' + params['msg'] +
        '\nValues:  ' + params['values'] +
        '\nFormula: ' + params['formula'])
        self.SendMail(params, msg, 'DISABLED')        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendDisabled
    def SendError(self, argin):
        """ 
        :param argin: 
        :type argin: PyTango.DevString
        """
        self.debug_stream("In SendError()")
        #----- PROTECTED REGION ID(AlarmMail.SendError) ENABLED START -----#
        params= {
        }
        prev_key=''
        prev_value=''
        for param in argin.split(';'):
            if len(param) == 0:
                continue
            try:
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                prev_key=param.split('=',1)[0]
                prev_value=param.split('=',1)[1]
            except IndexError as e:
                #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                self.debug_stream('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                params[prev_key] += ';'+param
        handler=''
        try:
            handler='\nHandler: ' + params['handler']
        except KeyError as e:
            handler=''
        state=''
        try:
            state='\nState:   ' + params['state']
        except KeyError as e:
            state=''
        ack=''
        try:
            ack='\nAck:     ' + params['ack']
        except KeyError as e:
            ack=''
        time_text=''
        try:
            time_text='\nTime:    ' + params['time']
        except KeyError as e:
            time_text=''
        msg = MIMEText('ERROR evaluating alarm: \nName:    ' +params['name'] +
        handler +
        state +
        ack +
        time_text +
        '\nMessage: ' + params['msg'] +
        '\nValues:  ' + params['values'] +
        '\nFormula: ' + params['formula'])
        self.SendMail(params, msg, 'ERROR')
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendError
    def SendNotifications(self, argin):
        """ 
        :param argin:     Array of semicolon separated arguments, ex:
            name=tagname;values={``alarm/beamstatus/0/medium2[0]``:0};url=;msg=``Test alarm``;formula=(alarm/beamstatus/0/medium2 == 1);groups=gr_ctrl;state=RTNUN;ack=0;dest= name@elettra.eu,;
        :type argin: PyTango.DevVarStringArray
        """
        self.debug_stream("In SendNotifications()")
        #----- PROTECTED REGION ID(AlarmMail.SendNotifications) ENABLED START -----#
        self.debug_stream("SendNotifications: argin size=" + str(len(argin)))
        if len(argin) == 1:
            self.SendNotification(argin[0])
            return
        notif_dict=dict()
        for arg in argin:
            self.debug_stream("SendNotifications: looping argin: " + arg)
            
            params= {
            }
            prev_key=''
            prev_value=''
            for param in arg.split(';'):
                if len(param) == 0:
                    continue
                try:
                    params[param.split('=',1)[0]] = param.split('=',1)[1]
                    prev_key=param.split('=',1)[0]
                    prev_value=param.split('=',1)[1]
                except IndexError as e:
                    #print('Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value)
                    self.debug_stream('SendNotifications: Error splitting ' + param + ' pre key=' + prev_key + ' prev_value='+prev_value) 
                    params[prev_key] += ';'+param
            #print(params)
            name=params['name']
            state=params['state']
            dest=params['dest']
            dest_list = dest.split(',')
            unique_dest_list = []
            for d in dest_list:
                params_list=list()
                if len(d) > 0 and d not in unique_dest_list:
                    unique_dest_list.append(d)
                    self.debug_stream('SendNotifications: found unique dest ' + str(d)) 
                    if len(d) > 0 and d in notif_dict:
                        params_list = notif_dict[d]
                        self.debug_stream('SendNotifications: existing params_list for ' + str(d) + ' len='+str(len(params_list))) 
                    params_list.append(params)
                    notif_dict[d] = params_list
                    self.debug_stream('SendNotifications: saving params_list for ' + str(d) + ' len='+str(len(params_list))) 

        for dest in notif_dict:
            _text = str()
            params_list = notif_dict[dest]
            subject = str(len(params_list)) + ' ALARMS'
            self.debug_stream('SendNotifications: looping  notif_dict for ' + str(dest) + ' len(params_list)='+str(len(params_list))) 
            params_mail = dict()
            params_mail['dest'] = dest
            for params in params_list:
                params_mail['name'] = params['name'] #TODO: assuming same in all notifications
                params_mail['msg'] = params['msg'] #TODO: assuming same in all notifications
                params_mail['groups'] = params['groups'] #TODO: assuming same in all notifications
                handler=''
                try:
                    handler='\nHandler: ' + params['handler']
                except KeyError as e:
                    handler=''
                state=''
                try:
                    state='\nState:   ' + params['state']
                except KeyError as e:
                    state=''
                ack=''
                try:
                    ack='\nAck:     ' + params['ack']
                except KeyError as e:
                    ack=''
                time_text=''
                try:
                    time_text='\nTime:    ' + params['time']
                except KeyError as e:
                    time_text=''
                try:
                    time_notif_text=params['time_notif']
                except KeyError as e:
                    time_notif_text=''
                _text += '\n-----'+time_notif_text+'-----\nName:    ' +params['name']
                _text += handler
                _text += state
                _text += ack
                _text += time_text
                _text += '\nMessage: ' + params['msg']
                _text += '\nValues:  ' + params['values']
                _text += '\nFormula: ' + params['formula'] + "\n"
            msg = MIMEText(_text)
            self.SendMail(params_mail, msg, subject)
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendNotifications

    #----- PROTECTED REGION ID(AlarmMail.programmer_methods) ENABLED START -----#
    def SendMail(self, params, msg, subject):
        self.debug_stream("In SendMail()")     
        msg['Subject'] = subject + ' ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'

        receive = ''        
        dest=''
        try:
            dest=params['dest']
        except KeyError as e:
            dest=''

        if len(dest) == 0:
            groups = params['groups']
            first = True
            for gr in groups.split('|'):
                    #print('looping gr=' + gr)
                    try:
                        #print('  -> address=' + self.addressBook[gr])
                        if first:
                                receive = receive + self.addressBook[gr]
                                first = False
                        else:
                                receive = receive + ',' + self.addressBook[gr]
                    except KeyError as e:
                        print('Cannot find email address for group ', str(gr))
                        print(e)
        else:
            receive = dest

        #print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()    
    #----- PROTECTED REGION END -----#	//	AlarmMail.programmer_methods


class AlarmMailClass(PyTango.DeviceClass):
    # -------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(AlarmMail.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	AlarmMail.global_class_variables


    #    Class Properties
    class_property_list = {
        }

    #    Device Properties
    device_property_list = {
        'receivers':
            [PyTango.DevVarStringArray, 
            "groupname=email",
             [] ],
        'email_name':
            [PyTango.DevString, 
            "email name",
            ["Control Alarms"] ],
        'email_smtp':
            [PyTango.DevString, 
            "SMTP server",
            ["smtp"] ],
        'email_user':
            [PyTango.DevString, 
            "email user",
             [] ],
        'hdbpp_user':
            [PyTango.DevString, 
             '',
             [] ],
        'hdbpp_password':
            [PyTango.DevString, 
             '',
             [],
            ],
        'hdbpp_host':
            [PyTango.DevString, 
             '',
             [],
            ],
        'hdbpp_dbname':
            [PyTango.DevString, 
             '',
             [],
            ],
        'egiga_url':
            [PyTango.DevString, 
            "eGiga url",
             [],
            ]
        }

    #    Command definitions
    cmd_list = {
        'SendAlarm':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendNormal':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendAlarmHDB':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendAlarmPROCFS':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendNotification':
            [[PyTango.DevString, "Semicolon separated arguments, ex:\nname=tagname;values={``alarm/beamstatus/0/medium2[0]``:0};url=;msg=``Test alarm``;formula=(alarm/beamstatus/0/medium2 == 1);groups=gr_ctrl;state=RTNUN;ack=0;dest= name@elettra.eu,;"],
            [PyTango.DevVoid, "none"]],
        'SendDisabled':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendError':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendNotifications':
            [[PyTango.DevVarStringArray, "Array of semicolon separated arguments, ex:\nname=tagname;values={``alarm/beamstatus/0/medium2[0]``:0};url=;msg=``Test alarm``;formula=(alarm/beamstatus/0/medium2 == 1);groups=gr_ctrl;state=RTNUN;ack=0;dest= name@elettra.eu,;"],
            [PyTango.DevVoid, "none"]],
        }

    #    Attribute definitions
    attr_list = {
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(AlarmMailClass, AlarmMail, 'AlarmMail')
        #----- PROTECTED REGION ID(AlarmMail.add_classes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print('-------> Received a DevFailed exception:', e)
    except Exception as e:
        print('-------> An unforeseen exception occurred....', e)


if __name__ == '__main__':
    main()
